import { debounce } from "@lincode/utils";
import { useEffect, useState } from "react";
export default (cb) => {
    const [dropEl, setDropEl] = useState();
    const [dragOver, setDragOver] = useState(false);
    useEffect(() => {
        if (!dropEl)
            return;
        const setDragOverDebounced = debounce((value) => setDragOver(value), 100, "trailing");
        let valueOld = false;
        const setDragOverTrack = (value) => {
            if (valueOld === value)
                return;
            valueOld = value;
            setDragOverDebounced(value);
        };
        const dragOverCb = (e) => {
            e.preventDefault();
            setDragOverTrack(true);
        };
        dropEl.addEventListener("dragover", dragOverCb);
        const dragEnterCb = (e) => {
            e.preventDefault();
            setDragOverTrack(true);
        };
        dropEl.addEventListener("dragenter", dragEnterCb);
        const dragLeaveCb = (e) => {
            e.preventDefault();
            setDragOverTrack(false);
        };
        dropEl.addEventListener("dragleave", dragLeaveCb);
        const dropCb = (e) => {
            e.preventDefault();
            setDragOverTrack(false);
            cb(e);
        };
        dropEl.addEventListener("drop", dropCb);
        return () => {
            dropEl.removeEventListener("dragover", dragOverCb);
            dropEl.removeEventListener("dragenter", dragEnterCb);
            dropEl.removeEventListener("dragleave", dragLeaveCb);
            dropEl.removeEventListener("drop", dropCb);
        };
    }, [dropEl]);
    return [setDropEl, dragOver];
};
